<?php

class AssetManager
{
	const ASSET_CSS = 0;
	const ASSET_JS = 1;
	const ASSET_IMAGE = 2;

	protected $assets = array(
		'js' => array(),
		'css' => array(),
		'image' => array(),
	);

	public function getAsset($type, array $parameters = array())
	{
		
	}

	// $filenames, $params = array(), $id = ''
	// @todo this should actually just 
	public function addJavascriptFile (JavascriptFile $file)
	{
		global $settings, $context, $db_show_debug;

		// dejvu?
		$cache_name = 'load_js_' . md5($settings['theme_dir'] . implode('_', $filenames));
		if (($temp = cache_get_data($cache_name, 600)) !== null)
		{
			if (empty($this->js_files))
				$this->js_files = array();
			$this->js_files += $temp;
		}
		else
		{
			// account for shorthand like admin.js?xyz11 filenames
			$has_cache_staler = strpos($filename, '.js?');
			$this_id = empty($id) ? strtr(basename($filename), '?', '_') : $id;

			// Is this a local file?
			if (substr($filename, 0, 4) !== 'http' || !empty($params['local']))
			{
				$params['local'] = true;
				$params['dir'] = $settings['theme_dir'] . '/scripts/';
				$params['url'] = $settings['theme_url'];

				// Fallback if we are not already in the default theme
				if ($params['fallback'] && ($settings['theme_dir'] !== $settings['default_theme_dir']) && !file_exists($settings['theme_dir'] . '/scripts/' . $filename))
				{
					// can't find it in this theme, how about the default?
					if (file_exists($settings['default_theme_dir'] . '/scripts/' . $filename))
					{
						$filename = $settings['default_theme_url'] . '/scripts/' . $filename . ($has_cache_staler ? '' : $params['stale']);
						$params['dir'] = $settings['default_theme_dir'] . '/scripts/';
						$params['url'] = $settings['default_theme_url'];
					}
					else
						$filename = false;
				}
				else
					$filename = $settings['theme_url'] . '/scripts/' . $filename . ($has_cache_staler ? '' : $params['stale']);
			}

			// Add it to the array for use in the template
			if (!empty($filename))
			{
				$this->js_files[$this_id] = array('filename' => $filename, 'options' => $params);

				if ($db_show_debug === true)
					$context['debug']['javascript'][] = $params['basename'] . '(' . (!empty($params['local']) ? (!empty($params['url']) ? basename($params['url']) : basename($params['dir'])) : '') . ')';
			}

			// Save it so we don't have to build this so often
			cache_put_data($cache_name, $this->js_files, 600);
		}

		return $this;
	}

	public function addCSSFile();
	public function addInlineStyle();
	public function addInlineJavascript();
	public function addJavascriptVar();

	public function combineJS();
	public function combineCSS();

	public function getJavascriptFiles();
	public function getCSSFiles();
	public function getInlineJavascript();
	public function getJavascriptVars();
	public function getInlineStyles();
}