<?php

class View
{
	public function __construct(TemplateManager $template_manager, AssetManager $asset_manager)
	{
		
	}

	public function loadTheme($id_theme = 0, $initialize = true)
	{
		global $user_info, $user_settings, $board_info;
		global $txt, $boardurl, $scripturl, $mbname, $modSettings;
		global $context, $settings, $options, $ssi_theme;

		$db = database();

		// The theme was specified by parameter.
		if (!empty($id_theme))
			$id_theme = (int) $id_theme;
		// The theme was specified by REQUEST.
		elseif (!empty($_REQUEST['theme']) && (!empty($modSettings['theme_allow']) || allowedTo('admin_forum')))
		{
			$id_theme = (int) $_REQUEST['theme'];
			$_SESSION['id_theme'] = $id_theme;
		}
		// The theme was specified by REQUEST... previously.
		elseif (!empty($_SESSION['id_theme']) && (!empty($modSettings['theme_allow']) || allowedTo('admin_forum')))
			$id_theme = (int) $_SESSION['id_theme'];
		// The theme is just the user's choice. (might use ?board=1;theme=0 to force board theme.)
		elseif (!empty($user_info['theme']) && !isset($_REQUEST['theme']) && (!empty($modSettings['theme_allow']) || allowedTo('admin_forum')))
			$id_theme = $user_info['theme'];
		// The theme was specified by the board.
		elseif (!empty($board_info['theme']))
			$id_theme = $board_info['theme'];
		// The theme is the forum's default.
		else
			$id_theme = $modSettings['theme_guests'];

		// Verify the id_theme... no foul play.
		// Always allow the board specific theme, if they are overriding.
		if (!empty($board_info['theme']) && $board_info['override_theme'])
			$id_theme = $board_info['theme'];
		// If they have specified a particular theme to use with SSI allow it to be used.
		elseif (!empty($ssi_theme) && $id_theme == $ssi_theme)
			$id_theme = (int) $id_theme;
		elseif (!empty($modSettings['knownThemes']) && !allowedTo('admin_forum'))
		{
			$themes = explode(',', $modSettings['knownThemes']);
			if (!in_array($id_theme, $themes))
				$id_theme = $modSettings['theme_guests'];
			else
				$id_theme = (int) $id_theme;
		}
		else
			$id_theme = (int) $id_theme;
	}

	// @todo move to MemberManager (they are member based)
	public function loadMemberThemeSettings()
	{
		$member = empty($user_info['id']) ? -1 : $user_info['id'];

		if (!empty($modSettings['cache_enable']) && $modSettings['cache_enable'] >= 2 && ($temp = cache_get_data('theme_settings-' . $id_theme . ':' . $member, 60)) != null && time() - 60 > $modSettings['settings_updated'])
		{
			$themeData = $temp;
			$flag = true;
		}
		elseif (($temp = cache_get_data('theme_settings-' . $id_theme, 90)) != null && time() - 60 > $modSettings['settings_updated'])
			$themeData = $temp + array($member => array());
		else
			$themeData = array(-1 => array(), 0 => array(), $member => array());

		if (empty($flag))
		{
			// Load variables from the current or default theme, global or this user's.
			$result = $db->query('', '
				SELECT variable, value, id_member, id_theme
				FROM {db_prefix}themes
				WHERE id_member' . (empty($themeData[0]) ? ' IN (-1, 0, {int:id_member})' : ' = {int:id_member}') . '
					AND id_theme' . ($id_theme == 1 ? ' = {int:id_theme}' : ' IN ({int:id_theme}, 1)'),
				array(
					'id_theme' => $id_theme,
					'id_member' => $member,
				)
			);
			// Pick between $settings and $options depending on whose data it is.
			while ($row = $db->fetch_assoc($result))
			{
				// There are just things we shouldn't be able to change as members.
				if ($row['id_member'] != 0 && in_array($row['variable'], array('actual_theme_url', 'actual_images_url', 'base_theme_dir', 'base_theme_url', 'default_images_url', 'default_theme_dir', 'default_theme_url', 'default_template', 'images_url', 'number_recent_posts', 'smiley_sets_default', 'theme_dir', 'theme_id', 'theme_layers', 'theme_templates', 'theme_url')))
					continue;

				// If this is the theme_dir of the default theme, store it.
				if (in_array($row['variable'], array('theme_dir', 'theme_url', 'images_url')) && $row['id_theme'] == '1' && empty($row['id_member']))
					$themeData[0]['default_' . $row['variable']] = $row['value'];

				// If this isn't set yet, is a theme option, or is not the default theme..
				if (!isset($themeData[$row['id_member']][$row['variable']]) || $row['id_theme'] != '1')
					$themeData[$row['id_member']][$row['variable']] = substr($row['variable'], 0, 5) == 'show_' ? $row['value'] == '1' : $row['value'];
			}
			$db->free_result($result);

			// Set the defaults if the user has not chosen on their own
			if (!empty($themeData[-1]))
			{
				foreach ($themeData[-1] as $k => $v)
				{
					if (!isset($themeData[$member][$k]))
						$themeData[$member][$k] = $v;
				}
			}

			if (!empty($modSettings['cache_enable']) && $modSettings['cache_enable'] >= 2)
				cache_put_data('theme_settings-' . $id_theme . ':' . $member, $themeData, 60);
			// Only if we didn't already load that part of the cache...
			elseif (!isset($temp))
				cache_put_data('theme_settings-' . $id_theme, array(-1 => $themeData[-1], 0 => $themeData[0]), 90);
		}
	}

	// @todo move to Controller
	public function detectURL()
	{
		// Check to see if they're accessing it from the wrong place.
		if (isset($_SERVER['HTTP_HOST']) || isset($_SERVER['SERVER_NAME']))
		{
			$detected_url = isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on' ? 'https://' : 'http://';
			$detected_url .= empty($_SERVER['HTTP_HOST']) ? $_SERVER['SERVER_NAME'] . (empty($_SERVER['SERVER_PORT']) || $_SERVER['SERVER_PORT'] == '80' ? '' : ':' . $_SERVER['SERVER_PORT']) : $_SERVER['HTTP_HOST'];
			$temp = preg_replace('~/' . basename($scripturl) . '(/.+)?$~', '', strtr(dirname($_SERVER['PHP_SELF']), '\\', '/'));
			if ($temp != '/')
				$detected_url .= $temp;
		}

		if (isset($detected_url) && $detected_url != $boardurl)
		{
			// Try #1 - check if it's in a list of alias addresses.
			if (!empty($modSettings['forum_alias_urls']))
			{
				$aliases = explode(',', $modSettings['forum_alias_urls']);
				foreach ($aliases as $alias)
				{
					// Rip off all the boring parts, spaces, etc.
					if ($detected_url == trim($alias) || strtr($detected_url, array('http://' => '', 'https://' => '')) == trim($alias))
						$do_fix = true;
				}
			}

			// Hmm... check #2 - is it just different by a www?  Send them to the correct place!!
			if (empty($do_fix) && strtr($detected_url, array('://' => '://www.')) == $boardurl && (empty($_GET) || count($_GET) == 1) && ELK != 'SSI')
			{
				// Okay, this seems weird, but we don't want an endless loop - this will make $_GET not empty ;).
				if (empty($_GET))
					redirectexit('wwwRedirect');
				else
				{
					list ($k, $v) = each($_GET);
					if ($k != 'wwwRedirect')
						redirectexit('wwwRedirect;' . $k . '=' . $v);
				}
			}

			// #3 is just a check for SSL...
			if (strtr($detected_url, array('https://' => 'http://')) == $boardurl)
				$do_fix = true;
		}
		$this->fixThemeSettings();
	}

	// @todo depends on detectURL()
	public function fixThemeSettings()
	{
		// Okay, #4 - perhaps it's an IP address?  We're gonna want to use that one, then. (assuming it's the IP or something...)
		if (!empty($do_fix) || preg_match('~^http[s]?://(?:[\d\.:]+|\[[\d:]+\](?::\d+)?)(?:$|/)~', $detected_url) == 1)
		{
			// Caching is good ;).
			$oldurl = $boardurl;

			// Fix $boardurl and $scripturl.
			$boardurl = $detected_url;
			$scripturl = strtr($scripturl, array($oldurl => $boardurl));
			$_SERVER['REQUEST_URL'] = strtr($_SERVER['REQUEST_URL'], array($oldurl => $boardurl));

			// Fix the theme urls...
			$settings['theme_url'] = strtr($settings['theme_url'], array($oldurl => $boardurl));
			$settings['default_theme_url'] = strtr($settings['default_theme_url'], array($oldurl => $boardurl));
			$settings['actual_theme_url'] = strtr($settings['actual_theme_url'], array($oldurl => $boardurl));
			$settings['images_url'] = strtr($settings['images_url'], array($oldurl => $boardurl));
			$settings['default_images_url'] = strtr($settings['default_images_url'], array($oldurl => $boardurl));
			$settings['actual_images_url'] = strtr($settings['actual_images_url'], array($oldurl => $boardurl));

			// And just a few mod settings :).
			$modSettings['smileys_url'] = strtr($modSettings['smileys_url'], array($oldurl => $boardurl));
			$modSettings['avatar_url'] = strtr($modSettings['avatar_url'], array($oldurl => $boardurl));

			// Clean up after loadBoard().
			if (isset($board_info['moderators']))
			{
				foreach ($board_info['moderators'] as $k => $dummy)
				{
					$board_info['moderators'][$k]['href'] = strtr($dummy['href'], array($oldurl => $boardurl));
					$board_info['moderators'][$k]['link'] = strtr($dummy['link'], array('"' . $oldurl => '"' . $boardurl));
				}
			}

			foreach ($context['linktree'] as $k => $dummy)
				$context['linktree'][$k]['url'] = strtr($dummy['url'], array($oldurl => $boardurl));
		}
	}
}